<template>
  <div class="app-container">

    <el-row :gutter="20">
      <!--部门数据-->
      <!-- <el-col :span="4" :xs="24">
        <div class="head-container">
          <el-input v-model="deptName" placeholder="请输入机构名称" clearable size="small" prefix-icon="el-icon-search"
                    style="margin-bottom: 20px"/>
        </div>
        <div class="tree-container">
          <div style="margin-bottom: 10px;">
            <el-checkbox v-model="queryParams.checkSub" @change="changeCheckBox">关联下级</el-checkbox>
          </div>
          <el-tree :data="deptOptions" :props="defaultProps" :expand-on-click-node="false"
                   :filter-node-method="filterNode" ref="tree" node-key="id" :default-expanded-keys="defaultKeys"
                   :default-checked-keys="defaultKeys" @node-click="handleNodeClick"/>
        </div>
      </el-col> -->
  <!--机构数据-->
  <el-col :span="4" :xs="24">

<org-tree v-model="queryParams.orgId" @defaultKey="getDefaultKey" @checkChange="checkChange"
  @click="clickTreeNode" businessTree></org-tree>
</el-col>

      <el-col :span="20" :xs="24">
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch">
          <el-form-item label="NFC点位" prop="checkName">
            <el-input v-model="queryParams.checkName" placeholder="请输入NFC点位名称" clearable
                      @keyup.enter.native="handleQuery"/>
          </el-form-item>
          <el-form-item label="区域名称" prop="areaId">
            <el-select v-model="queryParams.areaId" placeholder="请选择">
              <el-option v-for="item in areaList" :key="item.id" :label="item.name" :value="item.id"></el-option>
            </el-select>
          </el-form-item>
          <!-- <el-form-item label="归属部门" prop="orgId">
            <treeselect style="width: 160px;" v-model="queryParams.orgId" :options="deptOptions" :show-count="true"
              :normalizer="tenantIdnormalizer" :props="{ checkStrictly: true, label: 'name' }" placeholder="请选择归属部门" />
          </el-form-item> -->
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                       v-hasPermi="['system:check:add']">新增
            </el-button>
          </el-col>
          <!--    <el-col :span="1.5">
                <el-button type="success" plain icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate"
                  v-hasPermi="['system:check:edit']">修改</el-button>
              </el-col>
              <el-col :span="1.5">
                <el-button type="danger" plain icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete"
                  v-hasPermi="['system:check:remove']">删除</el-button>
              </el-col>-->
          <!-- <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport"
          v-hasPermi="['system:check:export']">导出</el-button>
      </el-col> -->
          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
        <el-table
          border
          height="600"
          size="small"
          v-loading="loading" :data="checkList" @selection-change="handleSelectionChange">
          <!--<el-table-column type="selection" width="55" align="center" />-->
          <el-table-column label="序号" align="center" min-width="50">
            <template v-slot:default="scope">
              <span v-text="getPageIndex(scope.$index)"> </span>
            </template>
          </el-table-column>
          <el-table-column label="所属机构" align="left" prop="orgName"/>
          <!-- <el-table-column label="区域名称" align="left" prop="areaName"/> -->
          <el-table-column label="NFC点位" align="left" prop="checkName"/>
          <el-table-column label="修改人" align="center" prop="updateBy"/>
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                         v-hasPermi="['system:check:edit']">编辑
              </el-button>
              <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                         v-hasPermi="['system:check:remove']">删除
              </el-button>
            </template>
          </el-table-column>
        </el-table>
        <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum"
                    :limit.sync="queryParams.pageSize"
                    @pagination="getList"/>
      </el-col>


    </el-row>


    <!-- 添加或修改区域采集点对话框 -->
    <DialogCom :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="110px">
        <el-row>
          <el-form-item label="所属机构" prop="orgId">
            <treeselect style="width: 100%;" v-model="form.orgId"
                        :options="deptOptions" :show-count="true"
                        :normalizer="tenantIdnormalizer" 
                        :props="{ checkStrictly: true, label: 'name' }" placeholder="请选择机构" @select="changeSelectArea"/>
          </el-form-item>
          <!-- <el-form-item label="区域名称" v-if="form.orgId!=null" prop="areaId">
            <el-select style="width: 100%;" v-model="form.areaId" placeholder="请选择区域名称">
              <el-option v-for="item in roleOptions" :key="item.id" :label="item.name" :value="item.id"></el-option>
            </el-select>
          </el-form-item> -->
        </el-row>
        <el-form-item label="NFC点位" prop="checkName">
          <el-input v-model="form.checkName" placeholder="请输入NFC点位名称"/>
        </el-form-item>
        <el-row>

        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </DialogCom>
  </div>
</template>

<script>
  import tableList from '@/mixins/tableList'
  import {listCheck, getCheck, delCheck, addCheck, updateCheck} from "@/api/system/check";
  import treeselect from '@riophae/vue-treeselect'
  import "@riophae/vue-treeselect/dist/vue-treeselect.css";
  import {deptTreeSelect,businessTreeSelect} from "@/api/system/public";
  import {listArea, getAreaByOrg} from "@/api/system/area";
  import orgTree from "@/components/orgTree";
  export default {
    name: "Check",
    /** 引入基础minxins*/
    mixins: [tableList],
    components: {treeselect,orgTree},
    dicts: ['sys_normal_disable'],
    data() {
      return {
        // 遮罩层
        loading: true,
        // 选中数组
        ids: [],
        names: [],
        // 非单个禁用
        single: true,
        //搜索tree
        deptName: null,
        // 非多个禁用
        multiple: true,
        // 显示搜索条件
        showSearch: true,
        //区域
        roleOptions: [],
        //搜索tree
        deptName: null,
        // 部门树选项
        deptOptions: [],
        // 总条数
        total: 0,
        //区域集合
        areaList: [],
        // 区域采集点表格数据
        checkList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          checkName: null,
          areaId: null,
          orgId: null,
          updateId: null,
          checkSub: true
        },
        // 表单参数
        form: {},
        // 表单校验
        checkList: [],
        roleOptions: [],
        defaultKeys: [],
        //是否关联下级
        checked: false,
        defaultProps: {
          children: "children",
          label: "name"
        },

        rules: {
          areaId: [
            {required: true, message: '请选择区域', trigger: 'blur'},
          ],
          orgId: [
            {required: true, message: '请选择归属部门', trigger: 'blur'},
          ],
          checkName: [
            {required: true, message: '请输入NFC点位名称', trigger: 'change'}
          ],
        },
        defaultKeys: []

      };
    },
    created() {
      this.getDeptTree();
      listArea().then(response => {
        this.areaList = response.rows;
      })

    },
    watch: {
      // 根据名称筛选部门树
      deptName(val) {
        this.$refs.tree.filter(val);
      }
    },
    methods: {
        // 节点单击事件
    clickTreeNode(data) {
      this.queryParams.orgId = data.id;
      this.handleQuery();
    },
         //单选框状态改变
    checkChange(state) {
      this.queryParams.checkSub = state;
      this.handleQuery();
    },
      getDefaultKey(key) {
      this.queryParams.orgId = key;
      this.getList();
    },
      getPageIndex($index) {
        //表格序号
        return (
          (this.queryParams.pageNum - 1) * this.queryParams.pageSize + $index + 1
        );
      },
      /** 下穿状态改变*/
      changeCheckBox() {
        this.getList();
      },
      // 筛选节点
      filterNode(value, data) {
        if (!value) return true;
        return data.name.indexOf(value) !== -1;
      },
      // 节点单击事件
      handleNodeClick(data) {
        this.queryParams.orgId = data.id;
        this.handleQuery();
      },
      changeSelectArea(val) {

        getAreaByOrg(val).then(response => {
          this.roleOptions = response.data;
          this.form.areaId = null;
        })
      },
      /** 查询区域采集点列表 */
      getList() {
        this.loading = true;
        listCheck(this.queryParams).then(response => {
          this.checkList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      },
      /** 查询部门下拉树结构 */
      getDeptTree() {
        // deptTreeSelect().then(response => {
        //   this.deptOptions = response.data;
        //   console.log(this.deptOptions, ' this.deptOptions')
        //   this.defaultKeys.push(response.data[0].id);
        //   this.queryParams.orgId = response.data[0].id;
        //   this.handleQuery();
        // });
        businessTreeSelect().then(response=>{
          this.deptOptions = response.data;
          this.defaultKeys.push(response.data[0].id);
           this.queryParams.orgId = response.data[0].id;
           this.handleQuery();
        })
      },
      tenantIdnormalizer(node, instanceId) {
        if (node.children && !node.children.length) {
          delete node.children
        }
        return {
          id: node.id,
          label: node.name,
          children: node.children
        }
      },
      // 节点单击事件
      handleNodeClick(data) {
        this.queryParams.orgId = data.id;
        this.handleQuery();
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          id: null,
          checkName: null,
          areaId: null,
          orgId: null,
          createTime: null,
          updateTime: null,
          updateId: null,
          createBy: null,
          delFlag: null,
          updateBy: null
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.names = selection.map(item => item.checkName)
        this.single = selection.length !== 1
        this.multiple = !selection.length
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        getCheck('').then(response => {

          this.roleOptions = response.areas;

          this.open = true;
          this.title = "新增";
          this.form.password = this.initPassword;
        });
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const id = row.id || this.ids

        getCheck(id).then(response => {
          this.form = response.data;
          this.roleOptions = response.areas;
          this.open = true;
          this.title = "编辑";
        });
      },
      /** 提交按钮 */
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id != null) {
              updateCheck(this.form).then(response => {
                this.$modal.msgSuccess("处理成功");
                this.open = false;
                this.getList();
              });
            } else {
              addCheck(this.form).then(response => {
                this.$modal.msgSuccess("处理成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id || this.ids;
        const names = row.checkName || this.names
        this.$modal.confirm('是否确认删除区域NFC点位名称为"' + names + '"的数据项？').then(function () {
          return delCheck(ids);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {
        });
      },
      /** 导出按钮操作 */
      handleExport() {
        this.download('system/check/export', {
          ...this.queryParams
        }, `check_${new Date().getTime()}.xlsx`)
      }
    }
  };
</script>
